/*
 * (c) Copyright 2002 - 2003 -- Anders Torger
 *
 * This program is open source. For license terms, see the LICENSE file.
 *
 */
#ifndef _SIMPLETAR_H_
#define _SIMPLETAR_H_

#include <stdio.h>

#include <zlib.h>

#include "defs.h"

#define TAR_PAD_SIZE(size) ((((size) + 511) & ~511) - (size))

struct simple_tar_header {
    char filename[100];
    int size;
};

bool_t
tar_header_read(FILE *stream,
                gzFile gzfile,
                struct simple_tar_header *tar_hdr);

int
tar_header_write(FILE *stream,
                 gzFile gzfile,
                 const struct simple_tar_header *tar_hdr);

bool_t
tar_add(const char path[],
        FILE *stream,
        gzFile gzfile);

#endif
