/*
 * (c) Copyright 2002 - 2003 -- Anders Torger
 *
 * This program is open source. For license terms, see the LICENSE file.
 *
 */
#ifndef _UI_SYSMON_H_
#define _UI_SYSMON_H_

#include "defs.h"
#include "almusvcu.h"

#define SYSMON_NA VCU_SYSINFO_NA

struct basic_sysinfo {
    int cpu_count;
    int cpu_speed;
    char cpu_modelname[80];
    int mem_total;
};

void
sysmon_sysinfo(struct basic_sysinfo *sysinfo);

void
sysmon_uptime(int *days,
	      int *hours);

int
sysmon_verify_bfir_device(const char bfir_device[],
                          const char bfir_device_params[],
                          bool_t isinput);

int
sysmon_sampling_rate(const char bfir_device[],
		     const char bfir_device_params[],
                     int open_channels,
                     int sample_format,
		     int suggested_sample_rate);

int
sysmon_n_cpus(void);

double
sysmon_cpuload(void);

double
sysmon_memused(void);

double
sysmon_temp(const char path[]);

bool_t
sysmon_dumpinfo(const char path[]);

#endif

