/*
 * (c) Copyright 2006 -- Anders Torger
 *
 * This program is open source. For license terms, see the LICENSE file.
 *
 */
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "xstr.h"

char *
escape_string(char buf[],
              const char str[])
{
    static char *_buf = NULL;
    static size_t bufcap = 0;
    int n, i;
    
    if (str == NULL) {
        return NULL;
    }
    if (buf == NULL) {
        if (4 * strlen(str) + 1 > bufcap) {
            bufcap = 4 * strlen(str) + 1;
            _buf = realloc(_buf, bufcap);
        }
        buf = _buf;
    }
    for (n = 0, i = 0; str[n] != '\0'; n++) {
        switch ((int)str[n]) {
        case 1 ... 6:
        case 14 ... 31:
        case 127 ... 160:
            sprintf(&buf[i], "\\%d", (int)str[n]);
            i += strlen(&buf[i]);
            break;
        case '\\': strcpy(&buf[i], "\\\\"); i += 2; break;
        case '\a': strcpy(&buf[i], "\\a"); i += 2; break;
        case '\b': strcpy(&buf[i], "\\b"); i += 2; break;
        case '\t': strcpy(&buf[i], "\\t"); i += 2; break;
        case '\n': strcpy(&buf[i], "\\n"); i += 2; break;
        case '\v': strcpy(&buf[i], "\\v"); i += 2; break;
        case '\f': strcpy(&buf[i], "\\f"); i += 2; break;
        case '\r': strcpy(&buf[i], "\\r"); i += 2; break;
        default:
            buf[i++] = str[n];
            break;
        }
    }
    buf[i] = '\0';
    return buf;
}
